//////////////////////////////////////////////////////////////
//                                                          //
//             MODULE DE STRUCTURES DE DONNEES              //
//                                                          //
//          MODULE DE CONTROLE DE LA DEMONSTRATION          //
//                                                          //
// Ce module assure les fonctions de controle au moyen de   //
//    boutons et d'un ascenceur. Il est possible d'arreter, //
//    suspendre, reprendre ou executer en pas a pas la      //
//    demonstration et den controler la vitesse.           //
//                                                          //
// Auteur: Christian CARREZ,                                //
// Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   //
// Derniere modification: 17 fevrier 2000                   //
//////////////////////////////////////////////////////////////

package Commun_Demonstration;

import java.awt.*; 
import java.awt.event.*;

public class ControleDemo extends Panel 
  implements ActionListener { 
 
  private boolean A_Suspendre ;
  private Button Suspension = new Button ("Suspendre");
  private boolean En_Continu = true ;
  private Button Continu = new Button ("Une etape");
  private final int ARRET = 0; 
  private final int SUSPENSION = 1; 
  private final int ACTIF = 2; 
  private int EtatProcessus = ACTIF;
  private int Delai; 
  private final int Delai_Min = 50;
  private final int Delai_Max = 1000; 
  private final int Delai_Incr = 100;
  private Scrollbar Vitesse; 
  private Panel Controle_Vitesse; 

  public ControleDemo (boolean EtatInit) { 
    Button b = null ;

    A_Suspendre = EtatInit ;
    if (A_Suspendre) Suspension.setLabel ("Reprendre");
    Delai = (Delai_Min + Delai_Max) / 2; 
    b = new Button ("Arreter");
    add(b) ;
    b.addActionListener (this) ; 
    add(Suspension) ;
    Suspension.addActionListener (this) ; 
    add(Continu) ;
    Continu.addActionListener (this) ; 
    b = new Button ("Un pas");
    add(b) ;
    b.addActionListener (this) ; 
    Controle_Vitesse = new Panel();
    Controle_Vitesse.setLayout(new BorderLayout());
    Controle_Vitesse.add("South", 
                         new Label("Lent      Vitesse     Rapide", 
                                     Label.CENTER));
    Vitesse = new Scrollbar(Scrollbar.HORIZONTAL, 
                            Delai_Max - Delai, Delai_Incr,
                            Delai_Min, Delai_Max);
    Controle_Vitesse.add("North", Vitesse);
    add(Controle_Vitesse);
  }
 
  public void actionPerformed (ActionEvent evt) { 
    String Etiquette = evt.getActionCommand() ;
    if (Etiquette.equals ("Arreter")) 
      synchronized (this) { 
        if (EtatProcessus == SUSPENSION) { 
          EtatProcessus = ARRET;
          notify();
        } else EtatProcessus = ARRET;
      } 
    else if (Etiquette.equals ("Suspendre")) { 
      Suspension.setLabel ("Reprendre");
      synchronized (this) { A_Suspendre = true; } 
    } else if (Etiquette.equals ("Reprendre")) { 
      Suspension.setLabel ("Suspendre");
      synchronized (this) { 
        A_Suspendre = false; 
        if (EtatProcessus == SUSPENSION) { 
          EtatProcessus = ACTIF;
          notify();
        } 
      } 
    } else if (Etiquette.equals ("Une etape")) { 
      Continu.setLabel (" Continu ");
      En_Continu = false; 
    } else if (Etiquette.equals (" Continu ")) { 
      Continu.setLabel ("Une etape");
      synchronized (this) {
        En_Continu = true; 
        if (EtatProcessus == SUSPENSION) { 
          EtatProcessus = ACTIF;
          notify();
        }
      }
    } else if (Etiquette.equals ("Un pas")) 
      synchronized (this) {
        if (EtatProcessus == SUSPENSION) { 
          EtatProcessus = ACTIF;
          notify();
        }
      } 
  } 

  public void Suspendre () throws StopAnim { 
    if (EtatProcessus == ARRET) throw new StopAnim (); 
    try {
      if (A_Suspendre) 
        synchronized (this) { 
          EtatProcessus = SUSPENSION;
          while (EtatProcessus == SUSPENSION) wait();
        } 
      else Thread.currentThread().sleep 
                     (Delai_Max - Vitesse.getValue() + Delai_Min);
    } catch (InterruptedException e) {
    }
    if (EtatProcessus == ARRET) throw new StopAnim ();
  } 
  
  public void FinEtape () throws StopAnim { 
    if (EtatProcessus == ARRET) throw new StopAnim ();
    if (En_Continu) return; 
    try {
      synchronized (this) { 
          EtatProcessus = SUSPENSION;
          while (EtatProcessus == SUSPENSION) wait();
      } 
    } catch (InterruptedException e) {
    } 
    if (EtatProcessus == ARRET) throw new StopAnim ();
  } 

  public boolean DemandeArret () { 
    return EtatProcessus == ARRET;
  } 

  public void AttenteArret () { 
    while (EtatProcessus != ARRET) { 
      try {
        synchronized (this) { 
          if (EtatProcessus == ARRET) return;
          EtatProcessus = SUSPENSION;
          while (EtatProcessus == SUSPENSION) wait();
        } 
      } catch (InterruptedException e) { 
      } 
    } 
  } 
} 
