//////////////////////////////////////////////////////////////
//                                                          //
//             MODULE DE STRUCTURES DE DONNEES              //
//                                                          //
//          MODULE D'AFFICHAGE DE LA LISTE A TRAITER        //
//                                                          //
// Ce module assure l'affichage de la liste a traiter       //
//                                                          //
// Auteur: Christian CARREZ,                                //
// Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   //
// Derniere modification: 4 avril 1999                      //
//////////////////////////////////////////////////////////////

package Commun_Demonstration;

import java.awt.*; 
import java.awt.event.*;


public class UneListe extends Canvas { 
  private int ieme [];
  private int ieme_tempo[];
  private int Nombre = 32;
  private boolean Liste_Ordonnee = true ;

  private int Pas_Min; 
  private int Pas_Max;

  public UneListe (int Taille, int Pas_Min, int Pas_Max) { 
    Nombre = Taille ; 
    this.Pas_Min = Pas_Min ; 
    this.Pas_Max = Pas_Max ;
    if (Nombre > Pas_Max) Nombre = Pas_Max; 
    if (Nombre < Pas_Min) Nombre = Pas_Min;
    ieme = new int[Nombre];
    ieme_tempo = new int[Nombre];
    for (int i = 0; i < Nombre; i++) ieme[i] = i + 1;
  } 

  public int getNombre () {
    return Nombre;
  }

  public boolean estOrdonnee () {
    return Liste_Ordonnee;
  }

  public int[] getListe () {
    return ieme;
  } 

  public void Corriger_Nombre (int Pas) { 
    int V = Nombre + Pas;
    if (V < Pas_Min) V = Pas_Min;
    else if (V > Pas_Max) V = Pas_Max;
    if (V != Nombre) { 
      ieme_tempo = new int[V]; 
      if (Nombre > V) Nombre = V;
      for (int i = 0; i < Nombre; i++) ieme_tempo[i] = ieme[i];
      ieme = new int [V]; 
      for (int i = 0; i < Nombre; i++) ieme[i] = ieme_tempo[i]; 
      for (int i = Nombre; i < V; i++) ieme[i] = i + 1;
      Nombre = V; 
      repaint() ;
    } 
  } 

  public void Ordonnee () { 
    for (int i = 0; i < ieme.length; i++) ieme[i] = i + 1; 
    Liste_Ordonnee = true ;
    repaint() ;
  }

  public void Aleatoire () { 
    int j;
    for (int i = 0; i < ieme.length; i++) 
      ieme_tempo[i] = 0; 
    for (int i = 0; i < ieme.length; i++) { 
      do 
        ieme[i] = (int) (((double)ieme.length) * Math.random()) + 1;
      while (ieme_tempo[ieme[i]-1] != 0); 
      ieme_tempo [ieme[i]-1] = ieme[i];
    } 
    Liste_Ordonnee = false ;
    repaint() ;
  } 

  public void paint (Graphics g) { 
    Rectangle r = getBounds() ;
    int Largeur;
    int Pas;
    int Hauteur;
    int cx, cy; 
    Hauteur = (r.height - 10) / ieme.length; 
    cy = (r.height - Hauteur * ieme.length)/2;
    Pas = (r.width - 10) / ieme.length;
    Largeur = Pas / 2; 
    cx = (r.width - Pas * ieme.length) / 2;
    g.setColor (Color.red);
    for (int i = 0; i < ieme.length; i++) { 
      g.fillRect (cx, cy + (ieme.length - ieme[i]) * Hauteur,
                  Largeur, ieme[i] * Hauteur); 
      cx = cx + Pas;
    } 
  } 
} 

