//////////////////////////////////////////////////////////////
//                                                          //
//          PROGRAMME DE STRUCTURES DE DONNEES              //
//                                                          //
//        APPLET DE DEMONSTRATION DES ARBRES AVL            //
//                                                          //
// Cette applet prepare la liste des elements a mettre      //
//    dans l'arbre                                          //
//                                                          //
// Auteur: Christian CARREZ,                                //
// Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   //
// Derniere modification: 7 avril 1999                      //
//////////////////////////////////////////////////////////////

package Demonstration_AVL;

import java.awt.*; 
import java.awt.event.*; 
import Commun_Demonstration.* ;

class LancementAnimation extends Panel implements ActionListener { 
  private Button Demarrage = new Button ("Demarrer");
  private UneListe maListe ; 
  private int L_Anim; 
  private int H_Anim; 
  private int TF_Anim;

  public LancementAnimation (UneListe maListe, 
                              int L_Anim, int H_Anim, int TF_Anim) { 
    this.maListe = maListe ; 
    this.L_Anim = L_Anim; 
    this.H_Anim = H_Anim; 
    this.TF_Anim = TF_Anim;
    setLayout (new FlowLayout());
    add(Demarrage) ; 
    Demarrage.addActionListener(this) ;
  } 

  public void actionPerformed (ActionEvent event) { 
    Animation_AVL Demo = null; 
    String Etiquette = event.getActionCommand();
    if (Etiquette.equals ("Demarrer")) { 
      Demo = new Animation_AVL (maListe.getListe(), 
                                 L_Anim, H_Anim, TF_Anim); 
      Demo.start ();
    } 
  }
}

public class Demo_D_AVL extends java.applet.Applet { 

  private NatureListe natureListe ;
  private LancementAnimation lancementAnimation ;;
  private UneListe maListe ;

  private final int Pas_Min = 10; 
  private final int Pas_Max = 63; 
  private int L_Min = 448; // adapte suivant la taille de fonte
  private final int L_Max = 1100;
  private int H_Min = 229; // adapte suivant la taille de fonte
  private final int H_Max = 800;
  private final int TF_Min = 8; 
  private final int TF_Max = 16;

  public void init() { 
    int Nombre = 32 ;
    int L_Anim = 640; // largeur fenetre animation defaut
    int H_Anim = 440; // hauteur fenetre animation defaut
    int TF_Anim = 14; // taille fonte par defaut

    String Param;
    Param = getParameter ("nombre");
    if (Param != null) Nombre = Integer.parseInt(Param); 
    Param = getParameter ("fonteAnimation");
    if (Param != null) TF_Anim = Integer.parseInt(Param); 
    if (TF_Anim > TF_Max) TF_Anim = TF_Max; 
    if (TF_Anim < TF_Min) TF_Anim = TF_Min;
    L_Min = (TF_Anim + 6) * 32;
    H_Min = L_Min * 4 /10 + 50;
    Param = getParameter ("hauteurAnimation");
    if (Param != null) H_Anim = Integer.parseInt(Param); 
    if (H_Anim > H_Max) H_Anim = H_Max; 
    if (H_Anim < H_Min) H_Anim = H_Min;
    Param = getParameter ("largeurAnimation");
    if (Param != null) L_Anim = Integer.parseInt(Param); 
    if (L_Anim > L_Max) L_Anim = L_Max; 
    if (L_Anim < L_Min) L_Anim = L_Min; 
    maListe = new UneListe (Nombre, Pas_Min, Pas_Max) ; 

    setLayout(new BorderLayout());

    lancementAnimation = 
          new LancementAnimation(maListe, L_Anim, H_Anim, TF_Anim); 
    add("North", lancementAnimation);
    add("Center", maListe);
    natureListe = new NatureListe(maListe); 
    add("South", natureListe);
  }
}
