//////////////////////////////////////////////////////////////
//                                                          //
//             MODULE DE STRUCTURES DE DONNEES              //
//                                                          //
//      MODULE D'ANIMATION DE LA DEMO D'ARBRES BALANCE      //
//                                                          //
// Ce module assure les fonctions generales d'affichage et  //
//    de surveillance de l'execution de l'animation des     //
//    operations sur les arbres balances. Le controle se    //
//    fait au moyen de boutons et d'un ascenceur. Il est    //
//    possible d'arreter, suspendre, reprendre ou executer  //
//    en pas a pas l'animation. L'ascenseur controle la     //
//    vitesse d'execution de lanimation. Le chemin courant //
//    est indique avec un fond vert. Le noeud courant est   //
//    indique par un fond magenta.                          //
//                                                          //
// Auteur: Christian CARREZ,                                //
// Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   //
// Derniere modification: 19 mai 2000                       //
//////////////////////////////////////////////////////////////

package Demonstration_BAL;

import java.awt.*; 
import java.awt.event.*;
import Commun_Demonstration.* ;

class Position_Affichage {
  Noeud_Balance Le_Noeud;
  int Indice; 
  int Pas_H;
  int cx;
  int cy; 
  int cxRect; 
  int H_Rect;
  int V_Rect;
  public Position_Affichage () {} 
} 

class NatureOperation extends Panel implements ActionListener { 
  private TextField Texte_Valeur;
  private TextField Phase; 
  int Valeur_Selectionnee;
  int Position; 
  final int RIEN = 0; 
  final int POSITIONNER = 1; 
  final int AJOUTER = 2; 
  final int SUPPRIMER = 3; 
  int Operation = RIEN;

  public NatureOperation () { 
    Button b = null ; 
    Phase = new TextField ("Attente", 30);
    Phase.setEditable (false);
//    Phase.setFont (new Font ("middleFont", 0, Taille_Fonte));
    add(Phase); 
    add (new Label ("Valeur: "));
    Texte_Valeur = new TextField ("", 2); 
    add(Texte_Valeur);
    b = new Button ("Positionner");
    add(b) ; 
    b.addActionListener (this) ; 
    b = new Button ("Ajouter");
    add(b) ; 
    b.addActionListener (this) ; 
    b = new Button ("Supprimer");
    add(b) ; 
    b.addActionListener (this) ; 
  }
 
  public void actionPerformed (ActionEvent evt) { 
    String Etiquette = evt.getActionCommand();
    if (Operation != RIEN) return;
    if (Etiquette.equals ("Positionner")) { 
      try {
        Valeur_Selectionnee =Integer.parseInt(Texte_Valeur.getText());
        Operation = POSITIONNER; 
      } catch (Exception e) { } 
    } else if (Etiquette.equals ("Ajouter")){ 
      try {
        Valeur_Selectionnee =Integer.parseInt(Texte_Valeur.getText());
        Operation = AJOUTER; 
      } catch (Exception e) { }
    } else if (Etiquette.equals ("Supprimer")) { 
        Operation = SUPPRIMER; 
    } 
  }

  public void Affiche_Phase (String S) { 
    Phase.setText (S);
  } 
} 

class Affiche_BAL extends Canvas { 

  private Arbre_Balance Arbre;
  private Animation_BAL Demo;
  private Image Image_Locale; 
  private Position_Affichage Chemin[];
  private int Sommet = -1;
  int Pas_V;

  private int Demi_H_Label; // par rapport au centre
  private int Demi_V_Label;
  private int Demi_H_Noeud; // taille du noeud
  private int Demi_V_Noeud; 
  private int Taille_Fonte;
 
  public Affiche_BAL (Animation_BAL Demo, 
                       int TF_Anim, Arbre_Balance L_Arbre) { 
    this.Demo = Demo; 
    Taille_Fonte = TF_Anim;
    Demi_V_Label = (TF_Anim / 2) - 1;
    Demi_H_Label = Demi_V_Label + 2;
    Demi_V_Noeud = Demi_H_Label;
    Demi_H_Noeud = Demi_V_Noeud + 1; 
    Arbre = L_Arbre;
    Chemin = new Position_Affichage [10]; 
    for (int i = 0; i < Chemin.length; i++) 
      Chemin[i] = new Position_Affichage ();
    Image_Locale = createImage (1000, 1000) ; 
  }

  private void Dessiner_Le_Noeud (Graphics g) { 
    Position_Affichage R = Chemin[Sommet]; 
    Position_Affichage Q; 
    g.setColor (Color.black); 
    if ((Sommet <= Arbre.Sommet)
         && (R.Le_Noeud == Arbre.Chemin[Sommet].Contenu))
      g.setColor (Color.green);
    if (Sommet > 0) { 
      Q = Chemin[Sommet-1]; 
      g.drawLine (Q.cx, Q.cy + Demi_V_Noeud,
                  Q.cx, R.cy - Demi_V_Noeud); 
    } 
    g.drawRect (R.cxRect, R.cy - Demi_V_Noeud-1, R.H_Rect, R.V_Rect); 
  } 
  private void Dessiner_La_Valeur (Graphics g) { 
    Position_Affichage R = Chemin[Sommet]; 
    Position_Affichage Q; 
    if (R.Indice > R.Le_Noeud.Degre()) return ;//pour les nuds vides 
    if ((Demo.Indice_Local == Sommet)
         && (R.Le_Noeud == Arbre.Chemin[Sommet].Contenu) 
         && (R.Indice == Arbre.Chemin[Sommet].Indice))
      g.setColor (Color.magenta);
    else if ((Sommet == Arbre.Sommet)
              && (R.Le_Noeud == Arbre.Chemin[Sommet].Contenu)
              && (R.Indice == Arbre.Chemin[Sommet].Indice))
      g.setColor (Color.green);
    else 
      g.setColor (Color.pink);
    g.fillRect (R.cx + R.Pas_H - Demi_H_Noeud, R.cy - Demi_V_Noeud,
                2 * Demi_H_Noeud, 2 * Demi_V_Noeud);
    g.setColor (Color.black);
    g.drawString("" + R.Le_Noeud.Ieme_Valeur (R.Indice), 
                 R.cx + R.Pas_H - Demi_H_Label, R.cy + Demi_V_Label);
  }
  private void Descendre_Fils (Graphics g) { 
    Position_Affichage R = Chemin[Sommet];
    Noeud_Balance NB; 
    NB = Chemin[Sommet].Le_Noeud.Ieme_Fils (Chemin[Sommet].Indice); 
    Sommet = Sommet + 1;;    // sur le bloc fils
    Chemin[Sommet].Le_Noeud = NB;
    Chemin[Sommet].Indice = 1;
    Chemin[Sommet].cy = R.cy + Pas_V; 
    Chemin[Sommet].Pas_H = R.Pas_H / (NB.Degre() + 1);
    Chemin[Sommet].cx = R.cx - NB.Degre() * Chemin[Sommet].Pas_H; 
    Chemin[Sommet].H_Rect = 2 * Chemin[Sommet].Pas_H * NB.Degre() + 4; 
    Chemin[Sommet].V_Rect = 2 * Demi_V_Noeud + 2; 
    if ((Chemin[Sommet].Pas_H <= Demi_H_Noeud) && (NB.Est_Feuille ())
         && NB.Degre () > 0) { 
      Chemin[Sommet].Pas_H = (R.Pas_H - 4) / NB.Degre();
      Chemin[Sommet].H_Rect = 2 * Chemin[Sommet].Pas_H * NB.Degre()+4;
      Chemin[Sommet].cx = R.cx - NB.Degre() * Chemin[Sommet].Pas_H; 
      if (Chemin[Sommet].Pas_H <= Demi_H_Noeud) { 
        int n = (R.Pas_H - 4) / (Demi_H_Noeud + 1);
        if (n > 0) Chemin[Sommet].Pas_H = (R.Pas_H - 4) / n; 
        else { 
          Chemin[Sommet].Pas_H = Demi_H_Noeud; 
          n = 1;
        }
        Chemin[Sommet].H_Rect = 2 * Chemin[Sommet].Pas_H * n + 4;
        Chemin[Sommet].cx = R.cx - n * Chemin[Sommet].Pas_H;
        Chemin[Sommet].V_Rect = ((NB.Degre() + n - 1) / n) 
                                           * (2 * Demi_V_Noeud + 2); 
      } 
    } ; 
    Chemin[Sommet].cxRect = Chemin[Sommet].cx - 2;
    Dessiner_Le_Noeud (g);
  } 
  private void Bord_Gauche (Graphics g){ 
      // recherche de la valeur la plus  gauche du sous-arbre
    do { 
      Descendre_Fils (g);
    } while (!Chemin[Sommet].Le_Noeud.Est_Feuille ());
  } 
  private void Valeur_Suivante () {   // remonte sur un bord droit
    while ((Sommet > 0) 
         && Chemin[Sommet].Indice > Chemin[Sommet].Le_Noeud.Degre()) {
      Sommet = Sommet - 1;
    } 
  }
  public void Positionner_Sur_Premier (Graphics g) {
    Sommet = 0;
    Chemin[0].Indice = 1; 
    Dessiner_Le_Noeud (g);
    if (!Chemin[0].Le_Noeud.Est_Feuille ()) Bord_Gauche (g); 
  } 
  public boolean A_La_Fin () { 
    return Sommet == 0 
         && Chemin[Sommet].Indice > (Chemin[Sommet].Le_Noeud).Degre();
  }
  public void Passer_Au_Suivant (Graphics g) { 
    Chemin[Sommet].Indice = Chemin[Sommet].Indice + 1;
    Chemin[Sommet].cx += 2 * Chemin[Sommet].Pas_H; 
    if (!Chemin[Sommet].Le_Noeud.Est_Feuille ()) Bord_Gauche (g); 
    else { 
      if (Chemin[Sommet].cx + Chemin[Sommet].Pas_H + Demi_H_Noeud 
                   >= Chemin[Sommet].cxRect + Chemin[Sommet].H_Rect) { 
        Chemin[Sommet].cx = Chemin[Sommet].cxRect + 2; 
        Chemin[Sommet].cy += 2 * Demi_V_Noeud + 2;
      } 
      Valeur_Suivante ();
    }
  }

  public void paint (Graphics g) { 
    Rectangle r = getBounds() ;
    Noeud_Balance NB = Arbre.Chemin[0].Contenu;
    Pas_V = (r.height - 2 * Demi_V_Noeud - 20) / (Chemin.length-2); 
    Chemin[0].Le_Noeud = NB;
    Chemin[0].Indice = 1;
    Chemin[0].Pas_H = (r.width - 20) / (2 * (NB.Degre() + 1));
    Chemin[0].cx = r.width / 2 - 10 - NB.Degre() * Chemin[0].Pas_H; 
    Chemin[0].cxRect = Chemin[0].cx - 2;
    Chemin[0].cy = 10 + Demi_V_Noeud; 
    Chemin[0].H_Rect = 2 * Chemin[0].Pas_H * NB.Degre() + 4; 
    Chemin[0].V_Rect = 2 * Demi_V_Noeud + 2; 
    g.setFont (new Font("bigFont", 0, Taille_Fonte));
    Positionner_Sur_Premier (g);
    while (!A_La_Fin ()) { 
      Dessiner_La_Valeur (g);
      Passer_Au_Suivant (g);
    } 
  } 

  public void update (Graphics g) { 
    Rectangle r = getBounds() ;
    if (Image_Locale == null)
      Image_Locale = createImage (1000, 1000);
    Graphics GL = Image_Locale.getGraphics();
    GL.setColor (getBackground ());
    GL.fillRect (0, 0, r.width, r.height);
    paint (GL);
    g.drawImage (Image_Locale, 0, 0, this);
  }
}

public class Animation_BAL extends Thread implements Affichage_BAL { 
  private NatureOperation natureOperation ;
  private Affiche_BAL afficheDemo; 
  private ControleDemo controleDemo ;
  private Frame f;
  private Arbre_Balance A;

  int Indice_Local;
  int ieme [];

  public Animation_BAL (int[] V_Init, int V_Ordre,
                         int L_Anim, int H_Anim, int TF_Anim) { 
    f = new Frame ("Animation sur les arbres balances");
    int Pas = 99 / V_Init.length;
    ieme = new int [V_Init.length];
    for (int i = 0; i < ieme.length; i++) { 
      ieme[i] = V_Init[i] * Pas; 
    } 
    f.setLayout(new BorderLayout()) ;
    natureOperation = new NatureOperation () ; 
    f.add("North", natureOperation); 
    A = new Arbre_Balance (V_Ordre, this);
    afficheDemo = new Affiche_BAL (this, TF_Anim, A); 
    f.add("Center", afficheDemo);
    controleDemo = new ControleDemo (true) ;
    f.add("South", controleDemo); 
    f.setSize (L_Anim, H_Anim); 
    f.show();
  } 

  public void Redessiner (int Indice) throws StopAnim { 
    Indice_Local = Indice;
    afficheDemo.repaint ();
    controleDemo.Suspendre();
  } 

  public void L_Animation () throws StopAnim { 
    int K; 
    for (K = 0; K < ieme.length; K++) { 
      natureOperation.Affiche_Phase ("Ajout de la valeur "+ieme[K]); 
      try {
        A.Ajouter (ieme[K]); 
        natureOperation.Affiche_Phase ("Fin de lajout de "+ieme[K]);
      } catch (IllegalArgumentException e) {
        natureOperation.Affiche_Phase ("Deja existant ");
      }
      Redessiner (-1);
      controleDemo.FinEtape();
    } 
    natureOperation.Affiche_Phase ("Plus de valeurs a ajouter ");
    while (!controleDemo.DemandeArret()) { 
      if (natureOperation.Operation == natureOperation.RIEN) try { 
          sleep (100);
      } catch (Exception e) {
      } 
      if (!controleDemo.DemandeArret() 
           && natureOperation.Operation != natureOperation.RIEN) {
        switch (natureOperation.Operation) { 
          case natureOperation.POSITIONNER: 
            natureOperation.Affiche_Phase ("Positionnement ");
            try { 
              A.Positionner (natureOperation.Valeur_Selectionnee); 
            } catch (IllegalArgumentException e) { 
              natureOperation.Affiche_Phase ("Non trouve ");
            } 
          break; 
          case natureOperation.AJOUTER: 
            natureOperation.Affiche_Phase ("Ajout de la valeur ");
            try {
              A.Ajouter (natureOperation.Valeur_Selectionnee); 
            } catch (IllegalArgumentException e) { 
              natureOperation.Affiche_Phase ("Deja existant ");
            } break; 
          case natureOperation.SUPPRIMER: 
            natureOperation.Affiche_Phase ("Supprimer le courant ");
            try {
              A.Supprimer_Courant ();
            } catch (IllegalArgumentException e) { 
              natureOperation.Affiche_Phase ("Noeud inexistant ");
            } break; 
        } 
        natureOperation.Operation = natureOperation.RIEN;
        Redessiner (-1); 
        natureOperation.Affiche_Phase ("Operation terminee ");
      }
    }
  }

  public void run () { 
    try { 
      L_Animation ();
    } catch (StopAnim e) { 
    } 
    controleDemo.AttenteArret();
    f.dispose();
  }
} 
