//////////////////////////////////////////////////////////////
//                                                          //
//          PROGRAMME DE STRUCTURES DE DONNEES              //
//                                                          //
//     APPLET DE DEMONSTRATION DES RECHERCHES EN LISTE      //
//                                                          //
// Cette applet prepare les listes pour la recherche ou le  //
//    tas (taille, generation), et son activation           //
//    independante. Pour une recherche, si la liste est     //
//    aleatoire, la recherche sequentielle est activee. Si  //
//    elle est ordonnee, cest la recherche dichotomique.   //
//                                                          //
// Auteur: Christian CARREZ,                                //
// Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   //
// Derniere modification: 15 fevrier 2000                   //
//////////////////////////////////////////////////////////////

package Demonstration_Recherche;

import java.awt.*; 
import java.awt.event.*; 
import Commun_Demonstration.* ;

class NatureRecherche extends Panel implements ActionListener { 
  private Button Recherche = new Button ("Recherche"); 
  private Button Tas = new Button ("Tas");
  private UneListe maListe ; 
  private int L_Anim; 
  private int H_Anim; 

  public NatureRecherche (UneListe maListe, int L_Anim, int H_Anim) { 
    this.maListe = maListe ; 
    this.L_Anim = L_Anim; 
    this.H_Anim = H_Anim; 
    setLayout (new FlowLayout());
    add(Recherche) ; 
    Recherche.addActionListener(this) ; 
    add(Tas) ; 
    Tas.addActionListener(this) ;
  } 

  public void actionPerformed (ActionEvent event) { 
    Algorithmes_Recherche Demo = null; 
    Gestion_Du_Tas Demo_Tas = null;
    String Etiquette = event.getActionCommand();
    if (Etiquette.equals ("Recherche")) { 
      if (maListe.estOrdonnee()) 
        Demo = new Recherche_Dich (maListe.getListe(), 
                                    L_Anim, H_Anim);
      else 
        Demo = new Recherche_Sequ (maListe.getListe(), 
                                    L_Anim, H_Anim);
      Demo.start ();
    } else if (Etiquette.equals ("Tas")) { 
      Demo_Tas = new Gestion_Du_Tas (maListe.getListe(), 
                                    L_Anim, H_Anim); 
      Demo_Tas.start ();
    }
  }
} 

public class Demo_De_Recherche extends java.applet.Applet { 

  private NatureListe natureListe ;
  private NatureRecherche natureRecherche ;
  private UneListe maListe; 

  private final int Pas_Min = 10; 
  private final int Pas_Max = 150;
  private final int L_Min = 415; 
  private final int L_Max = 1100;
  private final int H_Min = 220; 
  private final int H_Max = 800;

  public void init() { 
    int Nombre = 32 ;
    int L_Anim = 640; // largeur fenetre animation defaut
    int H_Anim = 440; // hauteur fenetre animation defaut

    String Param;
    Param = getParameter ("nombre");
    if (Param != null) Nombre = Integer.parseInt(Param); 
    Param = getParameter ("hauteurAnimation");
    if (Param != null) H_Anim = Integer.parseInt(Param); 
    if (H_Anim > H_Max) H_Anim = H_Max; 
    if (H_Anim < H_Min) H_Anim = H_Min;
    Param = getParameter ("largeurAnimation");
    if (Param != null) L_Anim = Integer.parseInt(Param); 
    if (L_Anim > L_Max) L_Anim = L_Max; 
    if (L_Anim < L_Min) L_Anim = L_Min; 
    maListe = new UneListe (Nombre, Pas_Min, Pas_Max) ; 

    setLayout(new BorderLayout());

    natureRecherche = new NatureRecherche(maListe, L_Anim, H_Anim); 
    add("North", natureRecherche);
    add("Center", maListe);
    natureListe = new NatureListe(maListe); 
    add("South", natureListe);
  }

}
