//////////////////////////////////////////////////////////////
//                                                          //
//             MODULE DE STRUCTURES DE DONNEES              //
//                                                          //
//          ALGORITHME DE RECHERCHE DICHOTOMIQUE            //
//                                                          //
// Cette classe derive la la classe abstraite               //
//    Algorithmes_Recherche et implemente la recherche      //
//    dichotomique                                          //
// proprietes fonctionnelles                                //
//    rech-dich(c, l, d, l) =                               //
//        si d = f alors d                                  //
//        sinon soit m = (d + f) / 2;                       //
//           si la_Cle(ieme(l, m) < c                       //
//           alors rech-dich (c, l, m+1, f)                 //
//           sinon rech-dich (c, l, d, m)                   //
//           fsi                                            //
//        fsi                                               //
//    Les valeurs recherchees sont tirees aleatoirement     //
//                                                          //
// Auteur: Christian CARREZ,                                //
// Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   //
// Derniere modification: 17 fevrier 2000                   //
//////////////////////////////////////////////////////////////

package Demonstration_Recherche;

import java.awt.*; 
import Commun_Demonstration.*;

public class Recherche_Dich extends Algorithmes_Recherche { 
  public Recherche_Dich (int[] V_Init, int L_Anim, int H_Anim) { 
    super(V_Init, L_Anim, H_Anim, " recherche dichotomique ");
  } 

  void La_Recherche () throws StopAnim {  // recherche dichotomique
    int J, K, Debut, Milieu, Fin;
    for (;;) { 
      Valeur_U = (int) (((double)ieme.length) * Math.random()) + 1;
      Redessiner ();
      Debut = 0;                    // recherche de sa place
      Fin = ieme.length-1;
      while (Debut < Fin) {
        Colors[Debut] = Color.blue; // on delimite la tranche
        Colors[Fin] = Color.blue; // on delimite la tranche
        Milieu = (Debut + Fin) / 2;
        Colors[Milieu] = Color.green;
        Redessiner ();
        Colors[Debut] = Color.red; // effacement de la tranche
        Colors[Fin] = Color.red; // effacement de la tranche
        Colors[Milieu] = Color.red;
        if (ieme[Milieu] < Valeur_U ) Debut = Milieu + 1;
        else Fin = Milieu;
      } 
      Valeur_U = 0;         // placement
      Redessiner ();
      controleDemo.FinEtape() ;
    } 
  } 
} 

