//////////////////////////////////////////////////////////////
//                                                          //
//             MODULE DE STRUCTURES DE DONNEES              //
//                                                          //
//         MODULE DE GESTION DU CONTROLE DES TABLES         //
//                                                          //
// Ce module assure les fonctions generales de controle des //
//    operations sur les tables.                            //
//                                                          //
// Auteur: Christian CARREZ,                                //
// Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   //
// Derniere modification: 20 septembre 2001                 //
//////////////////////////////////////////////////////////////

package Demonstration_Tables;

import java.awt.*; 
import java.awt.event.*;

class OperationsBases extends Panel implements ActionListener { 
  private TextField NumChI = new TextField ("", 3); 
  private TextField InfoChI = new TextField ("", 30); 
  private TextField NumIeme = new TextField ("", 3); 
  private TextField InfoIeme = new TextField ("", 30); 
  Table Tlocale;
 
  protected void makebutton (String S, GridBagLayout gb, 
                                        GridBagConstraints c) { 
    Button b = new Button (S);
    gb.setConstraints (b, c);
    add (b);
    b.addActionListener (this);
  } 

  public OperationsBases (Table TParam) { 
    Tlocale = TParam; 

    InfoIeme.setEditable (false); 

    GridBagLayout gridbag = new GridBagLayout ();
    GridBagConstraints c = new GridBagConstraints ();
    setLayout (gridbag);

    makebutton ("Changer-ieme", gridbag, c);
    gridbag.setConstraints (NumChI, c); 
    add (NumChI);
    c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints (InfoChI, c);
    add (InfoChI);

    c.gridwidth = 1;
    makebutton ("Ieme", gridbag, c);
    gridbag.setConstraints (NumIeme, c);
    add (NumIeme);
    c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints (InfoIeme, c);
    add (InfoIeme);

  }
 

  public void actionPerformed (ActionEvent evt) { 
    String Etiquette = evt.getActionCommand();
    int Indice;
    String Information;
    try { 
      if (Etiquette.equals ("Changer-ieme")) { 
        Indice =Integer.parseInt(NumChI.getText());
        Information = InfoChI.getText();
        if (!Tlocale.Changer_Ieme(Indice, Information)) { 
          AlertFrame AF = new AlertFrame ("\n    Hors intervalle"); 
        } 
      } else if (Etiquette.equals ("Ieme")){ 
        Indice =Integer.parseInt(NumIeme.getText());
        Information = Tlocale.Ieme(Indice);
        if (Information == null) { 
          Information = new String ();
          AlertFrame AF = new AlertFrame (
                                "\n    En dehors des specifications");
        } 
        InfoIeme.setText(Information); 
      } 
    } catch (NumberFormatException e) { 
      AlertFrame AF = new AlertFrame
                               ("\n    Erreur sur les parametres");
    }
  }
} 

class OperCompl extends Panel implements ActionListener { 
  private TextField NumDefini = new TextField ("", 3); 
  private TextField BoolDefini = new TextField ("", 30); 
  private TextField NumBinf = new TextField ("", 3);  
  private TextField NumBsup = new TextField ("", 3);  
  Table Tlocale;
 
  protected void makebutton (String S, GridBagLayout gb, 
                                        GridBagConstraints c) { 
    Button b = new Button (S);
    gb.setConstraints (b, c);
    add (b);
    b.addActionListener (this);
  } 

  public OperCompl (Table TParam) { 
    Tlocale = TParam; 

    BoolDefini.setEditable (false); 
    NumBinf.setEditable (false); 
    NumBsup.setEditable (false);

    GridBagLayout gridbag = new GridBagLayout ();
    GridBagConstraints c = new GridBagConstraints ();
    setLayout (gridbag);

    c.gridwidth = 1;
    makebutton ("Defini", gridbag, c);
    gridbag.setConstraints (NumDefini, c);
    add (NumDefini);
    c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints (BoolDefini, c);
    add (BoolDefini);

    c.gridwidth = 1;
    makebutton ("Borneinf", gridbag, c);
    c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints (NumBinf, c);
    add (NumBinf); 

    c.gridwidth = 1;
    makebutton ("Bornesup", gridbag, c);
    c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints (NumBsup, c);
    add (NumBsup);

  }
 

  public void actionPerformed (ActionEvent evt) { 
    String Etiquette = evt.getActionCommand();
    int Indice;
    String Information;
    try { 
      if (Etiquette.equals ("Defini")){ 
        Indice =Integer.parseInt(NumDefini.getText());
        if (Tlocale.Defini(Indice)) 
          BoolDefini.setText("Oui"); 
        else 
          BoolDefini.setText("Non");
      } else if (Etiquette.equals ("Borneinf")){ 
        NumBinf.setText (""+Tlocale.Bi());
      } else if (Etiquette.equals ("Bornesup")){ 
        NumBsup.setText (""+Tlocale.Bs());
      } 
    } catch (NumberFormatException e) { 
      AlertFrame AF = new AlertFrame
                                ("\n    Erreur sur les parametres");
    }
  }
}

class OperationsComplementaires extends Panel 
                                implements ActionListener { 
  Panel OperVide = new Panel();
  Button b = new Button ("Operations locales");
  CardLayout cl = new CardLayout ();
  public OperationsComplementaires (Table TParam) { 
    setLayout (cl);
    OperVide.add (b);
    b.addActionListener (this);
    add ("vide", OperVide);
    add ("plein", new OperCompl (TParam));
  } 
  
  public void actionPerformed (ActionEvent e) { 
    cl.show (this, "plein");
  } 
} 

class ControleDemo extends Panel implements ActionListener { 
  public boolean DemandeArret = false;
  public ControleDemo () { 
    Button b = new Button ("Dtruire");
    TextArea Definition = new TextArea (
        "   Une table est une structure de conservation d'une"
       +"\n   quantit fixe d'informations. Les informations sont"
       +"\n   identifies par un numro appartenant  un intervalle"
       +"\n   born. Elle permet de retrouver une information "
       +"\n   pralablement mmorise  partir de son sumro."
       +"\n"
       +"\n   En dehors de la cration, deux oprations de base:" 
       +"\n        Changer-ieme : table x entier x element -> table" 
       +"\n        ieme         : table x entier -> element",
       9, 45, TextArea.SCROLLBARS_NONE); 
    Definition.setEditable (false); 
    add(Definition); 
    add (b);
    b.addActionListener (this);
  }
  
  public void actionPerformed (ActionEvent e) { 
    DemandeArret = true;
  } 
} 

public class Animation_Tables extends Thread { 
  private ControleDemo controledemo = new ControleDemo (); 
  private Frame f;
  private Table TLocale;


  public Animation_Tables (int I, int J, int TF_Anim) { 
    f = new Frame ("Animation des Tables");
    f.setFont (new Font ("Helvetica", Font.PLAIN, TF_Anim));
    TLocale = new Table (I, J);
    f.setLayout(new BorderLayout());
    f.add("North", controledemo); 
    f.add("Center", new OperationsBases(TLocale)); 
    f.add ("South", new OperationsComplementaires (TLocale)); 
    f.pack () ;
    f.show();
  } 

  public void run () { 
    Thread thisThread = Thread.currentThread ();
    try { 
      while (!controledemo.DemandeArret) {
        thisThread.sleep(1000); 
      }
    } catch (InterruptedException e) { 
    } 
    f.dispose();
  }
} 
