//////////////////////////////////////////////////////////////
//                                                          //
//            MODULE DE DEMONSTRATION DES TABLES            //
//                                                          //
//                SPECIFICATION DES TABLES                  //
//                                                          //
// Ce module reprend les specifications des Tables          //
//                                                          //
// Auteur: Christian CARREZ,                                //
// Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   //
// Derniere modification: 18 septembre 2001                 //
//////////////////////////////////////////////////////////////

package Demonstration_Tables;

class Place {
  int          Numero;
  String       Contenu;
  Place        Suivant;
  Place (int N, String Obj) {
    Numero = N; 
    Contenu = new String (Obj); 
    Suivant = null;
  }
} 

public class Table {
  int bi, bs; // memorisation de l'intervalle de creation
  Place Tete;     // pointeur vers le premier couple 
  public Table (int i, int j) { 
    bi = i; bs = j; Tete = null; 
  } 
  public int Bi (){ return bi;}  
  public int Bs (){ return bs;} 
  public boolean Defini (int En) {
    Place P = Tete;
    while (P != null && P.Numero != En)
      P = P.Suivant;
    return (P != null); 
  }
  public String Ieme (int En) {
    Place P = Tete;
    while (P != null && P.Numero != En)
      P = P.Suivant;
    if (P == null) return null; 
    return new String(P.Contenu); 
  } 
  public boolean Changer_Ieme (int En, String Avec) {
    Place P = Tete; 
    if (En < bi || En > bs) return false; 
    if (P == null) Tete = new Place (En, Avec);
    else if (P.Numero == En) P.Contenu = new String (Avec); 
    else {
      while (P.Suivant != null && P.Suivant.Numero != En)
        P = P.Suivant;
      if (P.Suivant == null) P.Suivant = new Place (En, Avec);
      else P.Suivant.Contenu = new String (Avec);
    } 
    return true;
  } 
} 


