//////////////////////////////////////////////////////////////
//                                                          //
//          PROGRAMME DE STRUCTURES DE DONNEES              //
//                                                          //
//           APPLET DE DEMONSTRATION DES TRIS               //
//                                                          //
// Cette applet prepare les listes a trier (taille,         //
//    generation) permet le choix de lalgorithme de tri,   //
//    et son activation independante.                       //
//                                                          //
// Auteur: Christian CARREZ,                                //
// Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   //
// Derniere modification: 25 novembre 1999                  //
//////////////////////////////////////////////////////////////

package Demonstration_Tri;

import java.awt.*; 
import java.awt.event.*;
import Commun_Demonstration.* ;

class NatureTri extends Panel implements ActionListener { 
  private Choice List_Tri; 
  private Button Demarrage = new Button ("Demarrer");
  private UneListe maListe ; 
  private int L_Anim; 
  private int H_Anim; 

  public NatureTri (UneListe maListe, int L_Anim, int H_Anim) { 
    this.maListe = maListe ; 
    this.L_Anim = L_Anim; 
    this.H_Anim = H_Anim;
    List_Tri = new Choice();
    List_Tri.addItem ("sel. ordinaire"); 
    List_Tri.addItem ("bulle");
    List_Tri.addItem ("ins. sequentielle");
    List_Tri.addItem ("ins. dichotomique");
    List_Tri.addItem ("tri par tas"); 
    List_Tri.addItem ("tri par tas (arbre)");
    List_Tri.addItem ("tri rapide");
    List_Tri.select (0); 
    setLayout (new FlowLayout());
    add(List_Tri); 
    add(Demarrage) ; 
    Demarrage.addActionListener(this) ;
  } 

  public void actionPerformed (ActionEvent event) { 
    Thread Demo = null;
    int Numero_Tri; 
    String Etiquette = event.getActionCommand();
    if (Etiquette.equals ("Demarrer")) { 
      Numero_Tri = List_Tri.getSelectedIndex () + 1;
      if (Numero_Tri < 1) Numero_Tri = 1; 
      switch (Numero_Tri) { 
        case 1: Demo = new Tri_Sel_Ord (maListe.getListe(), 
                                         L_Anim, H_Anim);break; 
        case 2: Demo = new Tri_Bulle (maListe. getListe(),
                                       L_Anim, H_Anim); break; 
        case 3: Demo = new Tri_Ins_Seq (maListe.getListe(),
                                         L_Anim, H_Anim); break; 
        case 4: Demo = new Tri_Ins_Dich(maListe.getListe(),
                                         L_Anim, H_Anim); break; 
        case 5: Demo = new Tri_Tas (maListe.getListe(),
                                     L_Anim, H_Anim); break; ; 
        case 6: Demo = new Animation_Tas (maListe.getListe(),
                                           L_Anim, H_Anim); break;
        case 7: Demo = new Tri_Rapide (maListe.getListe(),
                                        L_Anim, H_Anim); break;
      } 
      Demo.start ();
    } 
  }
} 

public class Demo_De_Tri extends java.applet.Applet { 

  private NatureListe natureListe; 
  private NatureTri natureTri;
  private UneListe maListe ;

  private final int Pas_Min = 10; 
  private final int Pas_Max = 150;
  private final int L_Min = 415; 
  private final int L_Max = 1100;
  private final int H_Min = 220; 
  private final int H_Max = 800;

  public void init() { 
    int Nombre = 32 ; 
    int L_Anim = 640; // largeur fenetre animation defaut
    int H_Anim = 440; // hauteur fenetre animation defaut

    String Param;
    Param = getParameter ("nombre");
    if (Param != null) Nombre = Integer.parseInt(Param); 
    Param = getParameter ("hauteurAnimation");
    if (Param != null) H_Anim = Integer.parseInt(Param); 
    if (H_Anim > H_Max) H_Anim = H_Max; 
    if (H_Anim < H_Min) H_Anim = H_Min;
    Param = getParameter ("largeurAnimation");
    if (Param != null) L_Anim = Integer.parseInt(Param); 
    if (L_Anim > L_Max) L_Anim = L_Max; 
    if (L_Anim < L_Min) L_Anim = L_Min; 
    maListe = new UneListe (Nombre, Pas_Min, Pas_Max) ; 

    setLayout(new BorderLayout());
    natureTri = new NatureTri (maListe, L_Anim, H_Anim) ;
    add("North", natureTri); 
    add("Center", maListe) ;
    natureListe = new NatureListe(maListe);
    add("South", natureListe); 
  }
}
