//////////////////////////////////////////////////////////////
//                                                          //
//             MODULE DE STRUCTURES DE DONNEES              //
//                                                          //
//      ALGORITHMES DE TRI PAR INSERTION DICHOTOMIQUE       //
//                                                          //
// Cette classe derive la la classe abstraite               //
//    Algorithmes_Tri et implemente le tri par insertion    //
//    dichotomique                                          //
// proprietes fonctionnelles                                //
//    tri-ins-iter(l1, l) =                                 //
//        si l = listevide alors l1                         //
//        sinon tri-ins-iter(placer(premier(l),l1), fin(l)) //
//        fsi                                               //
//    tri (l) = tri-ins-iter(listevide, l)                  //
//                                                          //
// Auteur: Christian CARREZ,                                //
// Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   //
// Derniere modification: 17 fevrier 2000                   //
//////////////////////////////////////////////////////////////

package Demonstration_Tri;

import java.awt.*; 
import Commun_Demonstration.*;

public class Tri_Ins_Dich extends Algorithmes_Tri { 
  public Tri_Ins_Dich (int[] V_Init, int L_Anim, int H_Anim) { 
    super(V_Init, L_Anim, H_Anim, " insertion dichotomique ");
  } 

  void Le_Tri () throws StopAnim { 
                                    // tri par insertion dichotomique
    int J, K, Debut, Milieu, Fin;
    for (K = 1; K < ieme.length; K++) { 
      Colors[K] = Color.green;
      Colors[K-1] = Color.green;
      Redessiner ();
      Colors[K-1] = Color.red;
      if (ieme[K] < ieme[K - 1]) { 
        Valeur_U = ieme[K]; ieme[K] = 0; // il n'est pas  sa place
        Redessiner ();
        Debut = 0;                    // recherche de sa place
        Fin = K - 1;
       while (Debut < Fin) {
          Milieu = (Debut + Fin) / 2;
          Colors[Milieu] = Color.green;
          Redessiner ();
          Colors[Milieu] = Color.red;
          if (ieme[Milieu] < Valeur_U ) Debut = Milieu + 1;
          else Fin = Milieu;
        } 
        Colors[Debut] = Color.blue; // on delimite la tranche
        Colors[K] = Color.blue;
        for (J = K; J >= Debut + 1; J--) {
          ieme[J] = ieme[J-1]; ieme[J-1] = 0;       // dplacements
          Redessiner ();
          if (J != K) Colors[J] = Color.red;
          if (J == Debut+2) Colors[J-1] = Color.blue;
          else Colors[J-1] = Color.green;
        } 
        ieme[Debut] = Valeur_U; Valeur_U = 0;         // placement
        Redessiner ();
        Colors[Debut] = Color.red;
        Colors[K] = Color.red; 
      } 
      controleDemo.FinEtape() ;
    } 
    Redessiner ();
  } 
} 
