//////////////////////////////////////////////////////////////
//                                                          //
//             MODULE DE STRUCTURES DE DONNEES              //
//                                                          //
//      ALGORITHMES DE TRI PAR INSERTION SEQUENTIELLE       //
//                                                          //
// Cette classe derive la la classe abstraite               //
//    Algorithmes_Tri et implemente le tri par insertion    //
//    sequentielle                                          //
// proprietes fonctionnelles                                //
//    tri-ins-iter(l1, l) =                                 //
//        si l = listevide alors l1                         //
//        sinon tri-ins-iter(placer(premier(l),l1), fin(l)) //
//        fsi                                               //
//    tri (l) = tri-ins-iter(listevide, l)                  //
//                                                          //
// Auteur: Christian CARREZ,                                //
// Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   //
// Derniere modification: 17 fevrier 2000                   //
//////////////////////////////////////////////////////////////

package Demonstration_Tri;

import java.awt.*; 
import Commun_Demonstration.*;

public class Tri_Ins_Seq extends Algorithmes_Tri { 
  public Tri_Ins_Seq (int[] V_Init, int L_Anim, int H_Anim) { 
    super(V_Init, L_Anim, H_Anim, " insertion squentielle ");
  } 

  void Le_Tri () throws StopAnim { 
                                   // tri par insertion squentielle
    int K, L;
    for (K = 1; K < ieme.length; K++) {
      Valeur_U = ieme[K]; ieme[K] = 0;         // placement du Kime
      Redessiner ();
      L = K;                           // premire place possible
      Colors[L] = Color.green;
      Colors[L-1] = Color.green;
      Redessiner ();                 // pour la comparaison qui suit
      Colors[K] = Color.blue;        // marquer la fin liste triee
      while (L != 0 && Valeur_U < ieme[L - 1]) { 
        ieme[L] = ieme[L-1]; ieme[L-1] = 0;    // dplacement de L-1 
        Redessiner ();
        if (L != K) Colors[L] = Color.red;
        L = L - 1;                   // nouvelle place possible
        if (L > 1) { 
          Colors[L-1] = Color.green;
          Redessiner ();               // pour la comparaison
        } 
      } 
      if (L > 1) Colors[L-1] = Color.red;
      ieme[L] = Valeur_U; Valeur_U = 0;           // c'est la bonne
      Redessiner ();
      Colors[L] = Color.red;
      Colors[K] = Color.red; 
      controleDemo.FinEtape() ;
    } 
    Redessiner ();
  } 
} 
