//////////////////////////////////////////////////////////////
//                                                          //
//             MODULE DE STRUCTURES DE DONNEES              //
//                                                          //
//       ALGORITHMES DE TRI PAR SELECTION ORDINAIRE         //
//                                                          //
// Cette classe derive la la classe abstraite               //
//    Algorithmes_Tri et implemente le tri par selection    //
//    ordinaire                                             //
// proprietes fonctionnelles                                //
//    tri-sel-iter(l1, l) =                                 //
//        si l = listevide alors l1                         //
//        sinon tri-sel-iter(l1&[min(l)], supprimer-min(l)) //
//        fsi                                               //
//    tri (l) = tri-sel-iter(listevide, l)                  //
//                                                          //
// Auteur: Christian CARREZ,                                //
// Institution: CNAM 292 rue Saint Martin, 75141 Paris 03   //
// Derniere modification: 17 fevrier 2000                   //
//////////////////////////////////////////////////////////////

package Demonstration_Tri;

import java.awt.*; 
import Commun_Demonstration.*;

public class Tri_Sel_Ord extends Algorithmes_Tri { 
  public Tri_Sel_Ord (int[] V_Init, int L_Anim, int H_Anim) { 
    super(V_Init, L_Anim, H_Anim, "slection ordinaire");
  } 

  void Le_Tri () throws StopAnim { 
                                       // tri par slection simple
    int J, K, L; 
    for (K = 0; K < ieme.length - 1; K++) {
                             // recherche du Kime plus grand
      J = K;                         // premier candidat possible
      Colors[J] = Color.green;
      for (L = K + 1; L < ieme.length; L++) {
        Colors[L] = Color.green;
        Redessiner();
        if (ieme[L] < ieme [J]) { 
          Colors[J] = Color.red; 
          Colors[K] = Color.blue;      // marquage du premier
          J = L;                       // candidat meilleur
          Colors[J] = Color.green; 
        } else 
          Colors[L] = Color.red;
      } 
      Colors[K] = Color.green;
      Echanger (J, K);                             // rangement
      Colors[J] = Color.red;
      Colors[K] = Color.red;
      Redessiner() ;
      controleDemo.FinEtape() ;
    } 
    Redessiner ();
  } 
} 
